<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>

   <title>The Conway Channel: Events: Extreme Perl -- The Horror That Is <I>SelfGOL</I>
</title>
</head>
<body text="#009900" bgcolor="#000000" link="#009900" vlink="#006600" alink="#FFFF00">

<center><a href="index.html"><img SRC="../images/theConwayChannel.GIF" ALT="the conway channel" BORDER=0 height=41 width=356></a>
<br><img SRC="../images/events.GIF" ALT="events" BORDER=0 height=38 width=130></center>

<h2>&nbsp;</h2>
<h2>
<font face="Arial,Helvetica"><font color="#009999">Extreme Perl -- The Horror That Is <I>SelfGOL</I>
</font></font></h2>


<p><font face="Arial,Helvetica">
In this talk I dissect the <I>SelfGOL</I> program: an obfuscated, self-aware,
viral quine that can:


</font>

<p><font face="Arial,Helvetica">
<UL>
<LI> self-replicate,
<LI> rewrite other Perl programs to allow <I>them</I> to self-replicate,
<LI> detect un-rewritable Perl programs,
<LI> execute itself or other Perl programs as cellular automata of arbitrary size (to play Conway's "Game of Life"),
<LI> animate any short text as a cycling marquee banner.
</UL>


</font>

<p><font face="Arial,Helvetica">
<I>SelfGOL</I> accomplishes these feats in under 1000 bytes of standard Perl,
without importing any modules, and without using a single <FONT FACE="Courier" COLOR=WHITE>if</FONT>,
<FONT FACE="Courier" COLOR=WHITE>unless</FONT>, <FONT FACE="Courier" COLOR=WHITE>while</FONT>, <FONT FACE="Courier" COLOR=WHITE>until</FONT>, <FONT FACE="Courier" COLOR=WHITE>for</FONT>,
<FONT FACE="Courier" COLOR=WHITE>foreach</FONT>, <FONT FACE="Courier" COLOR=WHITE>goto</FONT>, <FONT FACE="Courier" COLOR=WHITE>next</FONT>,
<FONT FACE="Courier" COLOR=WHITE>last</FONT>, <FONT FACE="Courier" COLOR=WHITE>redo</FONT>, <FONT FACE="Courier" COLOR=WHITE>map</FONT>, or <FONT FACE="Courier" COLOR=WHITE>grep</FONT>.


</font>

<p><font face="Arial,Helvetica">
To do all that in under 1K of code, it relies on some extreme
programming techniques, and on many of the obscure backwaters
of the Perl syntax. This talk explores both.


</font>

<p><font face="Arial,Helvetica">
In other words, it's everything you never wanted to know about Perl, and
would have been afraid to ask.

</font>
</body>

</html>
